
/////////////////////////////////////////////////////////////
//
// Source file for StatFormUI
//
//    This class implements the user interface created in 
//    the interface builder. Normally it is not used directly.
//    Instead the subclass, StatForm is instantiated
//
//    To extend or alter the behavior of this class, you should
//    modify the StatForm files
//
//    Restrict changes to those sections between
//    the "//--- Start/End editable code block" markers
//
//    This will allow the builder to integrate changes more easily
//
//    This class is a ViewKit user interface "component".
//    For more information on how components are used, see the
//    "ViewKit Programmers' Manual", and the RapidApp
//    User's Guide.
//
//
/////////////////////////////////////////////////////////////


#include "StatFormUI.h" // Generated header file for this class

#include <Xm/Form.h> 
#include <Xm/Frame.h> 
#include <Xm/Label.h> 
#include <Xm/List.h> 
#include <Xm/PushB.h> 
#include <Xm/ScrolledW.h> 
#include <Xm/TextF.h> 
#include <Vk/VkResource.h>
//---- Start editable code block: headers and declarations


//---- End editable code block: headers and declarations



// These are default resources for widgets in objects of this class
// All resources will be prepended by *<name> at instantiation,
// where <name> is the name of the specific instance, as well as the
// name of the baseWidget. These are only defaults, and may be overriden
// in a resource file by providing a more specific resource name

String  StatFormUI::_defaultStatFormUIResources[] = {
        "*label17.labelString:  Video:",
        "*label16.labelString:  Participants:",
        "*label15.labelString:  Audio:",
        "*label26.labelString:  Lost:",
        "*label25.labelString:  Frames/sec:",
        "*label24.labelString:  Bandwidth:",
        "*label18.labelString:  Received:",
        "*label23.labelString:  Latency:",
        "*label22.labelString:  Total:",
        "*label21.labelString:  Bandwidth:",
        "*label20.labelString:  Late:",
        "*label19.labelString:  Lost:",
        "*label14.labelString:  Received:",
        "*statCloseButton.labelString:  Close",
        (char*)NULL
};

StatFormUI::StatFormUI(const char *name) : VkComponent(name) 
{ 
    // No widgets are created by this constructor.
    // If an application creates a component using this constructor,
    // It must explictly call create at a later time.
    // This is mostly useful when adding pre-widget creation
    // code to a derived class constructor.

    //---- Start editable code block: StatForm constructor 2


    //---- End editable code block: StatForm constructor 2


} // End Constructor




StatFormUI::StatFormUI(const char *name, Widget parent) : VkComponent(name) 
{ 
    // Call creation function to build the widget tree.

     create(parent);

    //---- Start editable code block: StatForm constructor


    //---- End editable code block: StatForm constructor


} // End Constructor


StatFormUI::~StatFormUI() 
{
    // Base class destroys widgets

    //---- Start editable code block: StatFormUI destructor


    //---- End editable code block: StatFormUI destructor
} // End destructor



void StatFormUI::create ( Widget parent )
{
    Arg      args[15];
    Cardinal count;
    count = 0;

    // Load any class-defaulted resources for this object

    setDefaultResources(parent, _defaultStatFormUIResources  );


    // Create an unmanaged widget as the top of the widget hierarchy

    _baseWidget = _statForm = XtVaCreateWidget ( _name,
                                                 xmFormWidgetClass,
                                                 parent, 
                                                 XmNresizePolicy, XmRESIZE_GROW, 
                                                 (XtPointer) NULL ); 

    // install a callback to guard against unexpected widget destruction

    installDestroyHandler();


    // Create widgets used in this component
    // All variables are data members of this class

    _label17 = XtVaCreateManagedWidget  ( "label17",
                                           xmLabelWidgetClass,
                                           _baseWidget, 
                                           XmNlabelType, XmSTRING, 
                                           XmNtopAttachment, XmATTACH_FORM, 
                                           XmNbottomAttachment, XmATTACH_NONE, 
                                           XmNleftAttachment, XmATTACH_FORM, 
                                           XmNrightAttachment, XmATTACH_NONE, 
                                           XmNtopOffset, 160, 
                                           XmNbottomOffset, 0, 
                                           XmNleftOffset, 210, 
                                           XmNrightOffset, 0, 
                                           XmNwidth, 60, 
                                           XmNheight, 30, 
                                           (XtPointer) NULL ); 


    _label16 = XtVaCreateManagedWidget  ( "label16",
                                           xmLabelWidgetClass,
                                           _baseWidget, 
                                           XmNlabelType, XmSTRING, 
                                           XmNtopAttachment, XmATTACH_FORM, 
                                           XmNbottomAttachment, XmATTACH_NONE, 
                                           XmNleftAttachment, XmATTACH_FORM, 
                                           XmNrightAttachment, XmATTACH_NONE, 
                                           XmNtopOffset, 0, 
                                           XmNbottomOffset, 0, 
                                           XmNleftOffset, 0, 
                                           XmNrightOffset, 0, 
                                           XmNwidth, 100, 
                                           XmNheight, 30, 
                                           (XtPointer) NULL ); 


    _label15 = XtVaCreateManagedWidget  ( "label15",
                                           xmLabelWidgetClass,
                                           _baseWidget, 
                                           XmNlabelType, XmSTRING, 
                                           XmNtopAttachment, XmATTACH_FORM, 
                                           XmNbottomAttachment, XmATTACH_NONE, 
                                           XmNleftAttachment, XmATTACH_FORM, 
                                           XmNrightAttachment, XmATTACH_NONE, 
                                           XmNtopPosition, 0, 
                                           XmNtopOffset, 0, 
                                           XmNbottomOffset, 0, 
                                           XmNleftOffset, 185, 
                                           XmNrightOffset, 0, 
                                           XmNwidth, 100, 
                                           XmNheight, 30, 
                                           (XtPointer) NULL ); 


    _statVideoFrame = XtVaCreateManagedWidget  ( "statVideoFrame",
                                                  xmFrameWidgetClass,
                                                  _baseWidget, 
                                                  XmNshadowType, XmSHADOW_IN, 
                                                  XmNtopAttachment, XmATTACH_WIDGET, 
                                                  XmNbottomAttachment, XmATTACH_NONE, 
                                                  XmNleftAttachment, XmATTACH_WIDGET, 
                                                  XmNrightAttachment, XmATTACH_NONE, 
                                                  XmNtopPosition, 0, 
                                                  XmNleftPosition, 0, 
                                                  XmNtopOffset, 30, 
                                                  XmNbottomOffset, 0, 
                                                  XmNleftOffset, 10, 
                                                  XmNrightOffset, 0, 
                                                  XmNwidth, 355, 
                                                  XmNheight, 110, 
                                                  (XtPointer) NULL ); 


    _statVideoForm = XtVaCreateManagedWidget  ( "statVideoForm",
                                                 xmFormWidgetClass,
                                                 _statVideoFrame, 
                                                 XmNresizePolicy, XmRESIZE_GROW, 
                                                 XmNwidth, 349, 
                                                 XmNheight, 104, 
                                                 (XtPointer) NULL ); 


    _label26 = XtVaCreateManagedWidget  ( "label26",
                                           xmLabelWidgetClass,
                                           _statVideoForm, 
                                           XmNlabelType, XmSTRING, 
                                           XmNtopAttachment, XmATTACH_FORM, 
                                           XmNbottomAttachment, XmATTACH_NONE, 
                                           XmNleftAttachment, XmATTACH_FORM, 
                                           XmNrightAttachment, XmATTACH_NONE, 
                                           XmNtopOffset, 60, 
                                           XmNbottomOffset, 0, 
                                           XmNleftOffset, 0, 
                                           XmNrightOffset, 0, 
                                           XmNwidth, 40, 
                                           XmNheight, 20, 
                                           (XtPointer) NULL ); 


    _label25 = XtVaCreateManagedWidget  ( "label25",
                                           xmLabelWidgetClass,
                                           _statVideoForm, 
                                           XmNlabelType, XmSTRING, 
                                           XmNtopAttachment, XmATTACH_FORM, 
                                           XmNbottomAttachment, XmATTACH_NONE, 
                                           XmNleftAttachment, XmATTACH_FORM, 
                                           XmNrightAttachment, XmATTACH_NONE, 
                                           XmNtopOffset, 20, 
                                           XmNbottomOffset, 0, 
                                           XmNleftOffset, 160, 
                                           XmNrightOffset, 0, 
                                           XmNwidth, 90, 
                                           XmNheight, 20, 
                                           (XtPointer) NULL ); 


    _videoLostText = XtVaCreateManagedWidget  ( "videoLostText",
                                                 xmTextFieldWidgetClass,
                                                 _statVideoForm, 
                                                 XmNeditable, False, 
                                                 XmNtopAttachment, XmATTACH_FORM, 
                                                 XmNbottomAttachment, XmATTACH_NONE, 
                                                 XmNleftAttachment, XmATTACH_FORM, 
                                                 XmNrightAttachment, XmATTACH_NONE, 
                                                 XmNtopOffset, 55, 
                                                 XmNbottomOffset, 0, 
                                                 XmNleftOffset, 75, 
                                                 XmNrightOffset, 0, 
                                                 XmNwidth, 85, 
                                                 XmNheight, 30, 
                                                 (XtPointer) NULL ); 
    XtVaSetValues ( _videoLostText, 
                    XmNbackground, 
                    (Pixel) VkGetResource ( _videoLostText,
                                            "readOnlyBackground",
                                            "ReadOnlyBackground",
                                            XmRPixel, "Black" ),
                    NULL );

    _videoFpsText = XtVaCreateManagedWidget  ( "videoFpsText",
                                                xmTextFieldWidgetClass,
                                                _statVideoForm, 
                                                XmNeditable, False, 
                                                XmNtopAttachment, XmATTACH_FORM, 
                                                XmNbottomAttachment, XmATTACH_NONE, 
                                                XmNleftAttachment, XmATTACH_FORM, 
                                                XmNrightAttachment, XmATTACH_NONE, 
                                                XmNtopOffset, 15, 
                                                XmNbottomOffset, 0, 
                                                XmNleftOffset, 250, 
                                                XmNrightOffset, 0, 
                                                XmNwidth, 85, 
                                                XmNheight, 30, 
                                                (XtPointer) NULL ); 
    XtVaSetValues ( _videoFpsText, 
                    XmNbackground, 
                    (Pixel) VkGetResource ( _videoFpsText,
                                            "readOnlyBackground",
                                            "ReadOnlyBackground",
                                            XmRPixel, "Black" ),
                    NULL );

    _videoBdwText = XtVaCreateManagedWidget  ( "videoBdwText",
                                                xmTextFieldWidgetClass,
                                                _statVideoForm, 
                                                XmNeditable, False, 
                                                XmNtopAttachment, XmATTACH_FORM, 
                                                XmNbottomAttachment, XmATTACH_NONE, 
                                                XmNleftAttachment, XmATTACH_FORM, 
                                                XmNrightAttachment, XmATTACH_NONE, 
                                                XmNtopOffset, 55, 
                                                XmNbottomOffset, 0, 
                                                XmNleftOffset, 250, 
                                                XmNrightOffset, 0, 
                                                XmNwidth, 85, 
                                                XmNheight, 30, 
                                                (XtPointer) NULL ); 
    XtVaSetValues ( _videoBdwText, 
                    XmNbackground, 
                    (Pixel) VkGetResource ( _videoBdwText,
                                            "readOnlyBackground",
                                            "ReadOnlyBackground",
                                            XmRPixel, "Black" ),
                    NULL );

    _label24 = XtVaCreateManagedWidget  ( "label24",
                                           xmLabelWidgetClass,
                                           _statVideoForm, 
                                           XmNlabelType, XmSTRING, 
                                           XmNtopAttachment, XmATTACH_FORM, 
                                           XmNbottomAttachment, XmATTACH_NONE, 
                                           XmNleftAttachment, XmATTACH_FORM, 
                                           XmNrightAttachment, XmATTACH_NONE, 
                                           XmNtopOffset, 60, 
                                           XmNbottomOffset, 0, 
                                           XmNleftOffset, 165, 
                                           XmNrightOffset, 0, 
                                           XmNwidth, 82, 
                                           XmNheight, 20, 
                                           (XtPointer) NULL ); 


    _videoRecText = XtVaCreateManagedWidget  ( "videoRecText",
                                                xmTextFieldWidgetClass,
                                                _statVideoForm, 
                                                XmNeditable, False, 
                                                XmNtopAttachment, XmATTACH_FORM, 
                                                XmNbottomAttachment, XmATTACH_NONE, 
                                                XmNleftAttachment, XmATTACH_FORM, 
                                                XmNrightAttachment, XmATTACH_NONE, 
                                                XmNtopOffset, 15, 
                                                XmNbottomOffset, 0, 
                                                XmNleftOffset, 75, 
                                                XmNrightOffset, 0, 
                                                XmNwidth, 85, 
                                                XmNheight, 30, 
                                                (XtPointer) NULL ); 
    XtVaSetValues ( _videoRecText, 
                    XmNbackground, 
                    (Pixel) VkGetResource ( _videoRecText,
                                            "readOnlyBackground",
                                            "ReadOnlyBackground",
                                            XmRPixel, "Black" ),
                    NULL );

    _label18 = XtVaCreateManagedWidget  ( "label18",
                                           xmLabelWidgetClass,
                                           _statVideoForm, 
                                           XmNlabelType, XmSTRING, 
                                           XmNtopAttachment, XmATTACH_FORM, 
                                           XmNbottomAttachment, XmATTACH_NONE, 
                                           XmNleftAttachment, XmATTACH_FORM, 
                                           XmNrightAttachment, XmATTACH_NONE, 
                                           XmNtopOffset, 15, 
                                           XmNbottomOffset, 0, 
                                           XmNleftOffset, 0, 
                                           XmNrightOffset, 0, 
                                           XmNwidth, 75, 
                                           XmNheight, 25, 
                                           (XtPointer) NULL ); 


    _statAudioFrame = XtVaCreateManagedWidget  ( "statAudioFrame",
                                                  xmFrameWidgetClass,
                                                  _baseWidget, 
                                                  XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET, 
                                                  XmNbottomAttachment, XmATTACH_NONE, 
                                                  XmNleftAttachment, XmATTACH_WIDGET, 
                                                  XmNrightAttachment, XmATTACH_NONE, 
                                                  XmNtopPosition, 0, 
                                                  XmNleftPosition, 0, 
                                                  XmNrightPosition, 0, 
                                                  XmNtopOffset, 0, 
                                                  XmNbottomOffset, 0, 
                                                  XmNleftOffset, 10, 
                                                  XmNrightOffset, 0, 
                                                  XmNwidth, 355, 
                                                  XmNheight, 130, 
                                                  (XtPointer) NULL ); 


    _statAudioForm = XtVaCreateManagedWidget  ( "statAudioForm",
                                                 xmFormWidgetClass,
                                                 _statAudioFrame, 
                                                 XmNresizePolicy, XmRESIZE_GROW, 
                                                 XmNchildType, XmFRAME_WORKAREA_CHILD, 
                                                 XmNwidth, 349, 
                                                 XmNheight, 124, 
                                                 (XtPointer) NULL ); 


    _audioLatencyText = XtVaCreateManagedWidget  ( "audioLatencyText",
                                                    xmTextFieldWidgetClass,
                                                    _statAudioForm, 
                                                    XmNeditable, False, 
                                                    XmNtopAttachment, XmATTACH_FORM, 
                                                    XmNbottomAttachment, XmATTACH_NONE, 
                                                    XmNleftAttachment, XmATTACH_FORM, 
                                                    XmNrightAttachment, XmATTACH_NONE, 
                                                    XmNtopOffset, 85, 
                                                    XmNbottomOffset, 0, 
                                                    XmNleftOffset, 250, 
                                                    XmNrightOffset, 0, 
                                                    XmNwidth, 85, 
                                                    XmNheight, 30, 
                                                    (XtPointer) NULL ); 
    XtVaSetValues ( _audioLatencyText, 
                    XmNbackground, 
                    (Pixel) VkGetResource ( _audioLatencyText,
                                            "readOnlyBackground",
                                            "ReadOnlyBackground",
                                            XmRPixel, "Black" ),
                    NULL );

    _audioTotalText = XtVaCreateManagedWidget  ( "audioTotalText",
                                                  xmTextFieldWidgetClass,
                                                  _statAudioForm, 
                                                  XmNeditable, False, 
                                                  XmNtopAttachment, XmATTACH_FORM, 
                                                  XmNbottomAttachment, XmATTACH_NONE, 
                                                  XmNleftAttachment, XmATTACH_FORM, 
                                                  XmNrightAttachment, XmATTACH_NONE, 
                                                  XmNtopOffset, 5, 
                                                  XmNbottomOffset, 0, 
                                                  XmNleftOffset, 250, 
                                                  XmNrightOffset, 0, 
                                                  XmNwidth, 85, 
                                                  XmNheight, 30, 
                                                  (XtPointer) NULL ); 
    XtVaSetValues ( _audioTotalText, 
                    XmNbackground, 
                    (Pixel) VkGetResource ( _audioTotalText,
                                            "readOnlyBackground",
                                            "ReadOnlyBackground",
                                            XmRPixel, "Black" ),
                    NULL );

    _label23 = XtVaCreateManagedWidget  ( "label23",
                                           xmLabelWidgetClass,
                                           _statAudioForm, 
                                           XmNalignment, XmALIGNMENT_BEGINNING, 
                                           XmNlabelType, XmSTRING, 
                                           XmNtopAttachment, XmATTACH_FORM, 
                                           XmNbottomAttachment, XmATTACH_NONE, 
                                           XmNleftAttachment, XmATTACH_FORM, 
                                           XmNrightAttachment, XmATTACH_NONE, 
                                           XmNtopOffset, 85, 
                                           XmNbottomOffset, 0, 
                                           XmNleftOffset, 165, 
                                           XmNrightOffset, 0, 
                                           XmNwidth, 63, 
                                           XmNheight, 20, 
                                           (XtPointer) NULL ); 


    _label22 = XtVaCreateManagedWidget  ( "label22",
                                           xmLabelWidgetClass,
                                           _statAudioForm, 
                                           XmNalignment, XmALIGNMENT_BEGINNING, 
                                           XmNlabelType, XmSTRING, 
                                           XmNtopAttachment, XmATTACH_FORM, 
                                           XmNbottomAttachment, XmATTACH_NONE, 
                                           XmNleftAttachment, XmATTACH_FORM, 
                                           XmNrightAttachment, XmATTACH_NONE, 
                                           XmNtopOffset, 10, 
                                           XmNbottomOffset, 0, 
                                           XmNleftOffset, 165, 
                                           XmNrightOffset, 0, 
                                           XmNwidth, 43, 
                                           XmNheight, 20, 
                                           (XtPointer) NULL ); 


    _audioBwdText = XtVaCreateManagedWidget  ( "audioBwdText",
                                                xmTextFieldWidgetClass,
                                                _statAudioForm, 
                                                XmNeditable, False, 
                                                XmNtopAttachment, XmATTACH_FORM, 
                                                XmNbottomAttachment, XmATTACH_NONE, 
                                                XmNleftAttachment, XmATTACH_FORM, 
                                                XmNrightAttachment, XmATTACH_NONE, 
                                                XmNtopOffset, 45, 
                                                XmNbottomOffset, 0, 
                                                XmNleftOffset, 250, 
                                                XmNrightOffset, 0, 
                                                XmNwidth, 85, 
                                                XmNheight, 30, 
                                                (XtPointer) NULL ); 
    XtVaSetValues ( _audioBwdText, 
                    XmNbackground, 
                    (Pixel) VkGetResource ( _audioBwdText,
                                            "readOnlyBackground",
                                            "ReadOnlyBackground",
                                            XmRPixel, "Black" ),
                    NULL );

    _label21 = XtVaCreateManagedWidget  ( "label21",
                                           xmLabelWidgetClass,
                                           _statAudioForm, 
                                           XmNlabelType, XmSTRING, 
                                           XmNtopAttachment, XmATTACH_FORM, 
                                           XmNbottomAttachment, XmATTACH_NONE, 
                                           XmNleftAttachment, XmATTACH_WIDGET, 
                                           XmNrightAttachment, XmATTACH_NONE, 
                                           XmNleftPosition, 0, 
                                           XmNtopOffset, 50, 
                                           XmNbottomOffset, 0, 
                                           XmNleftOffset, 5, 
                                           XmNrightOffset, 0, 
                                           XmNwidth, 82, 
                                           XmNheight, 20, 
                                           (XtPointer) NULL ); 


    _label20 = XtVaCreateManagedWidget  ( "label20",
                                           xmLabelWidgetClass,
                                           _statAudioForm, 
                                           XmNlabelType, XmSTRING, 
                                           XmNtopAttachment, XmATTACH_FORM, 
                                           XmNbottomAttachment, XmATTACH_NONE, 
                                           XmNleftAttachment, XmATTACH_FORM, 
                                           XmNrightAttachment, XmATTACH_NONE, 
                                           XmNtopOffset, 85, 
                                           XmNbottomOffset, 0, 
                                           XmNleftOffset, 0, 
                                           XmNrightOffset, 0, 
                                           XmNwidth, 40, 
                                           XmNheight, 20, 
                                           (XtPointer) NULL ); 


    _label19 = XtVaCreateManagedWidget  ( "label19",
                                           xmLabelWidgetClass,
                                           _statAudioForm, 
                                           XmNlabelType, XmSTRING, 
                                           XmNtopAttachment, XmATTACH_FORM, 
                                           XmNbottomAttachment, XmATTACH_NONE, 
                                           XmNleftAttachment, XmATTACH_FORM, 
                                           XmNrightAttachment, XmATTACH_NONE, 
                                           XmNtopOffset, 50, 
                                           XmNbottomOffset, 0, 
                                           XmNleftOffset, 0, 
                                           XmNrightOffset, 0, 
                                           XmNwidth, 40, 
                                           XmNheight, 20, 
                                           (XtPointer) NULL ); 


    _audioLateText = XtVaCreateManagedWidget  ( "audioLateText",
                                                 xmTextFieldWidgetClass,
                                                 _statAudioForm, 
                                                 XmNeditable, False, 
                                                 XmNtopAttachment, XmATTACH_WIDGET, 
                                                 XmNbottomAttachment, XmATTACH_NONE, 
                                                 XmNleftAttachment, XmATTACH_FORM, 
                                                 XmNrightAttachment, XmATTACH_NONE, 
                                                 XmNtopPosition, 0, 
                                                 XmNtopOffset, 10, 
                                                 XmNbottomOffset, 0, 
                                                 XmNleftOffset, 75, 
                                                 XmNrightOffset, 0, 
                                                 XmNwidth, 85, 
                                                 XmNheight, 30, 
                                                 (XtPointer) NULL ); 
    XtVaSetValues ( _audioLateText, 
                    XmNbackground, 
                    (Pixel) VkGetResource ( _audioLateText,
                                            "readOnlyBackground",
                                            "ReadOnlyBackground",
                                            XmRPixel, "Black" ),
                    NULL );

    _audioLostText = XtVaCreateManagedWidget  ( "audioLostText",
                                                 xmTextFieldWidgetClass,
                                                 _statAudioForm, 
                                                 XmNeditable, False, 
                                                 XmNtopAttachment, XmATTACH_WIDGET, 
                                                 XmNbottomAttachment, XmATTACH_NONE, 
                                                 XmNleftAttachment, XmATTACH_FORM, 
                                                 XmNrightAttachment, XmATTACH_NONE, 
                                                 XmNtopPosition, 0, 
                                                 XmNtopOffset, 10, 
                                                 XmNbottomOffset, 0, 
                                                 XmNleftOffset, 75, 
                                                 XmNrightOffset, 0, 
                                                 XmNwidth, 85, 
                                                 XmNheight, 30, 
                                                 (XtPointer) NULL ); 
    XtVaSetValues ( _audioLostText, 
                    XmNbackground, 
                    (Pixel) VkGetResource ( _audioLostText,
                                            "readOnlyBackground",
                                            "ReadOnlyBackground",
                                            XmRPixel, "Black" ),
                    NULL );

    _label14 = XtVaCreateManagedWidget  ( "label14",
                                           xmLabelWidgetClass,
                                           _statAudioForm, 
                                           XmNlabelType, XmSTRING, 
                                           XmNtopAttachment, XmATTACH_FORM, 
                                           XmNbottomAttachment, XmATTACH_NONE, 
                                           XmNleftAttachment, XmATTACH_FORM, 
                                           XmNrightAttachment, XmATTACH_NONE, 
                                           XmNtopOffset, 10, 
                                           XmNbottomOffset, 0, 
                                           XmNleftOffset, 0, 
                                           XmNrightOffset, 0, 
                                           XmNwidth, 75, 
                                           XmNheight, 20, 
                                           (XtPointer) NULL ); 


    _audioRecText = XtVaCreateManagedWidget  ( "audioRecText",
                                                xmTextFieldWidgetClass,
                                                _statAudioForm, 
                                                XmNeditable, False, 
                                                XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET, 
                                                XmNbottomAttachment, XmATTACH_NONE, 
                                                XmNleftAttachment, XmATTACH_WIDGET, 
                                                XmNrightAttachment, XmATTACH_NONE, 
                                                XmNtopWidget, _label14, 
                                                XmNleftWidget, _label14, 
                                                XmNtopPosition, 0, 
                                                XmNleftPosition, 0, 
                                                XmNtopOffset, -5, 
                                                XmNbottomOffset, 0, 
                                                XmNleftOffset, 0, 
                                                XmNrightOffset, 0, 
                                                XmNwidth, 85, 
                                                XmNheight, 30, 
                                                (XtPointer) NULL ); 
    XtVaSetValues ( _audioRecText, 
                    XmNbackground, 
                    (Pixel) VkGetResource ( _audioRecText,
                                            "readOnlyBackground",
                                            "ReadOnlyBackground",
                                            XmRPixel, "Black" ),
                    NULL );

    XtVaSetValues ( _label21, 
                    XmNleftWidget, _audioLostText, 
                    (XtPointer) NULL );
    XtVaSetValues ( _audioLateText, 
                    XmNtopWidget, _audioLostText, 
                    (XtPointer) NULL );
    XtVaSetValues ( _audioLostText, 
                    XmNtopWidget, _audioRecText, 
                    (XtPointer) NULL );
    _frame = XtVaCreateManagedWidget  ( "frame",
                                         xmFrameWidgetClass,
                                         _baseWidget, 
                                         XmNtopAttachment, XmATTACH_FORM, 
                                         XmNbottomAttachment, XmATTACH_NONE, 
                                         XmNleftAttachment, XmATTACH_FORM, 
                                         XmNrightAttachment, XmATTACH_NONE, 
                                         XmNtopOffset, 30, 
                                         XmNbottomOffset, 0, 
                                         XmNleftOffset, 10, 
                                         XmNrightOffset, 0, 
                                         XmNwidth, 195, 
                                         XmNheight, 270, 
                                         (XtPointer) NULL ); 


    _statPartsForm = XtVaCreateManagedWidget  ( "statPartsForm",
                                                 xmFormWidgetClass,
                                                 _frame, 
                                                 XmNresizePolicy, XmRESIZE_GROW, 
                                                 XmNwidth, 189, 
                                                 XmNheight, 264, 
                                                 (XtPointer) NULL ); 


    _statUsersScroll = XtVaCreateManagedWidget  ( "statUsersScroll",
                                                   xmScrolledWindowWidgetClass,
                                                   _statPartsForm, 
                                                   XmNscrollingPolicy, XmAPPLICATION_DEFINED, 
                                                   XmNscrollBarDisplayPolicy, XmSTATIC, 
                                                   XmNtopAttachment, XmATTACH_FORM, 
                                                   XmNbottomAttachment, XmATTACH_NONE, 
                                                   XmNleftAttachment, XmATTACH_FORM, 
                                                   XmNrightAttachment, XmATTACH_NONE, 
                                                   XmNtopOffset, 5, 
                                                   XmNbottomOffset, 0, 
                                                   XmNleftOffset, 10, 
                                                   XmNrightOffset, 0, 
                                                   XmNwidth, 170, 
                                                   XmNheight, 210, 
                                                   (XtPointer) NULL ); 


    _statUsersList = XtVaCreateManagedWidget  ( "statUsersList",
                                                 xmListWidgetClass,
                                                 _statUsersScroll, 
                                                 XmNselectionPolicy, XmSINGLE_SELECT, 
                                                 XmNlistSizePolicy, XmVARIABLE, 
                                                 XmNwidth, 164, 
                                                 XmNheight, 204, 
                                                 (XtPointer) NULL ); 

    XtAddCallback ( _statUsersList,
                    XmNsingleSelectionCallback,
                    &StatFormUI::statUserSelectedCallback,
                    (XtPointer) this ); 


    _statCloseButton = XtVaCreateManagedWidget  ( "statCloseButton",
                                                   xmPushButtonWidgetClass,
                                                   _statPartsForm, 
                                                   XmNlabelType, XmSTRING, 
                                                   XmNtopAttachment, XmATTACH_FORM, 
                                                   XmNbottomAttachment, XmATTACH_NONE, 
                                                   XmNleftAttachment, XmATTACH_FORM, 
                                                   XmNrightAttachment, XmATTACH_NONE, 
                                                   XmNtopOffset, 225, 
                                                   XmNbottomOffset, 0, 
                                                   XmNleftOffset, 55, 
                                                   XmNrightOffset, 0, 
                                                   XmNwidth, 60, 
                                                   XmNheight, 35, 
                                                   (XtPointer) NULL ); 

    XtAddCallback ( _statCloseButton,
                    XmNactivateCallback,
                    &StatFormUI::statCloseCallback,
                    (XtPointer) this ); 


    XtVaSetValues ( _statVideoFrame, 
                    XmNtopWidget, _statAudioFrame, 
                    XmNleftWidget, _frame, 
                    (XtPointer) NULL );
    XtVaSetValues ( _statAudioFrame, 
                    XmNtopWidget, _frame, 
                    XmNleftWidget, _frame, 
                    (XtPointer) NULL );
    //---- Start editable code block: StatFormUI create


    //---- End editable code block: StatFormUI create
}

const char * StatFormUI::className()
{
    return ("StatFormUI");
} // End className()




/////////////////////////////////////////////////////////////// 
// The following functions are static member functions used to 
// interface with Motif.
/////////////////////////////////// 

void StatFormUI::statCloseCallback ( Widget    w,
                                     XtPointer clientData,
                                     XtPointer callData ) 
{ 
    StatFormUI* obj = ( StatFormUI * ) clientData;
    obj->statClose ( w, callData );
}

void StatFormUI::statUserSelectedCallback ( Widget    w,
                                            XtPointer clientData,
                                            XtPointer callData ) 
{ 
    StatFormUI* obj = ( StatFormUI * ) clientData;
    obj->statUserSelected ( w, callData );
}



/////////////////////////////////////////////////////////////// 
// The following functions are called from the menu items 
// in this window.
/////////////////////////////////// 

void StatFormUI::statClose ( Widget, XtPointer ) 
{
    // This virtual function is called from statCloseCallback.
    // This function is normally overriden by a derived class.

}

void StatFormUI::statUserSelected ( Widget, XtPointer ) 
{
    // This virtual function is called from statUserSelectedCallback.
    // This function is normally overriden by a derived class.

}



